# This file was generated by the `rspec --init` command. Conventionally, all
# specs live under a `spec` directory, which RSpec adds to the `$LOAD_PATH`.
# Require this file using `require "spec_helper"` to ensure that it is only
# loaded once.
#
# See http://rubydoc.info/gems/rspec-core/RSpec/Core/Configuration

require 'pathname'
lib = Pathname.new(__FILE__).parent.parent.join('lib').to_s
$LOAD_PATH << lib
require 'webmock/rspec'
require 'pry'

RSpec.configure do |config|
  # Use color not only in STDOUT but also in pagers and files
  config.tty = true
end

# Boilerplate for all tests.
#
# All tests need to authenticate before they can do anything, so mock it out.
RSpec.shared_context 'credentials' do
  let :credentials do
    {
      :server   => 'http://rt.example.org',
      :username => 'admin',
      :password => 'password'
    }
  end

  before(:each) do
    mocks_path = Pathname.new(__FILE__).parent.join('mocks')

    stub_request(:post, 'http://rt.example.org/index.html')
      .with(:body => {
              'user' => 'admin',
              'pass' => 'password'
            })
      .to_return(:status => 200,
                 :body    => mocks_path.join('ticket-create.txt').read,
                 :headers => {})

    stub_request(:get, 'http://rt.example.org/REST/1.0/ticket/1/show')
      .to_return(:status  => 200,
                 :body    => mocks_path.join('ticket-1-show.txt').read,
                 :headers => {})
  end
end
